/***********************************************************************
*
* Copyright (c) 2012-2016 Barbara Geller
* Copyright (c) 2012-2016 Ansel Sermersheim
* Copyright (c) 2012-2014 Digia Plc and/or its subsidiary(-ies).
* Copyright (c) 2008-2012 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
*
* This file is part of CopperSpice.
*
* CopperSpice is free software: you can redistribute it and/or 
* modify it under the terms of the GNU Lesser General Public License
* version 2.1 as published by the Free Software Foundation.
*
* CopperSpice is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with CopperSpice.  If not, see 
* <http://www.gnu.org/licenses/>.
*
***********************************************************************/

#ifndef QQUEUE_H
#define QQUEUE_H

#include <QtCore/qlist.h>

QT_BEGIN_NAMESPACE

template <class T>
class QQueue : public QList<T>
{
 public:
   inline QQueue() {}
   inline ~QQueue() {}

   inline void swap(QQueue<T> &other) {
      QList<T>::swap(other);   // prevent QList<->QQueue swaps
   }

   inline void enqueue(const T &t) {
      QList<T>::append(t);
   }

   inline T dequeue() {
      return QList<T>::takeFirst();
   }

   inline T &head() {
      return QList<T>::first();
   }

   inline const T &head() const {
      return QList<T>::first();
   }
};

QT_END_NAMESPACE

#endif // QQUEUE_H
